<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities\Util as Util;

class Endereco extends \Teknisa\MAN\Controllers\TeknisaCrud {

    protected $enderecoService,
              $utilService,
              $dataSourceName,
              $crudService,
              $dataSourceNamePais = "cadVendedor_pais",
              $dataSourceNameEstado = "cadVendedor_estado",
              $dataSourceNameMunicipio = "cadVendedor_municipio",
              $dataSourceNameBairro = "cadVendedor_bairro";

    public function __construct($crudService, $parameterBag, $entityManager, Services\Endereco $enderecoService, Util $utilService) {
        $this->crudService = $crudService;
        $this->parameterBag 			= $parameterBag;
		$this->entityManager 			= $entityManager;
        $this->enderecoService = $enderecoService;
        $this->utilService = $utilService;
    }

    public function buscaPais(Request\Filter $request, Response $response) {
        $this->dataSourceName = $this->dataSourceNamePais;
        parent::find($request, $response);
    }

    public function buscaEstado(Request\Filter $request, Response $response) {
        $this->dataSourceName = $this->dataSourceNameEstado;
        parent::find($request, $response);
    }

    public function buscaMunicipio(Request\Filter $request, Response $response) {
        $this->dataSourceName = $this->dataSourceNameMunicipio;
        parent::find($request, $response);
    }

    public function buscaBairro(Request\Filter $request, Response $response) {
        $this->dataSourceName = $this->dataSourceNameBairro;
        parent::find($request, $response);
    }    
    
    public function buscaEnderecoPorCEP(Request\Row $request, Response $response) {
        $params = $this->utilService->getParamsAsArray($request); 
        
        $NRORG = $params['NRORG'];
        $NRCEP = $params['NRCEP'];

        $buscaEnderecoPorCEP = $this->enderecoService->buscaEnderecoPorCEP($NRORG, $NRCEP);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Endereco', $buscaEnderecoPorCEP));
    }
}